Description

Redmine provides redmine_plugin_model generator. It's similar to model generator by Rails but for Redmine plugin. It's useful to add

a new model to Redmine plugin.

But Redmine doesn't provide redmine_plugin_migration generator. It's similar to migration generator by Rails but for Redmine plugin.

It's useful to improve existing models in Redmine plugin.

We need to create a migration file for Redmine plugin by hand without redmine_plugin_migration.

The attached patch implements redmine_plugin_migration generator. It only has the minimal features:

Assign a new migration version.

Just create a migration file that only has empty change method.

The migration generator by Rails has more features:

Intelligent migration content generator. For example it can generate a migration content for creating a table from

create_TABLE_NAME migration name: 

https://github.com/rails/rails/blob/master/activerecord/lib/rails/generators/active_record/migration/migration_generator.rb#L39-L4

1

Migration name validation: 

https://github.com/rails/rails/blob/master/activerecord/lib/rails/generators/active_record/migration/migration_generator.rb#L65-L6

9

Accept more options. For example, attributes are accepted: 

https://github.com/rails/rails/blob/master/activerecord/lib/rails/generators/active_record/migration/migration_generator.rb#L8

I think that minimum implementation is a good starting point.

This implementation uses the framework for migration provided by Rails: 

https://github.com/rails/rails/blob/master/railties/lib/rails/generators/migration.rb

Associated revisions

Revision 18223 - 2019-06-03 16:56 - Go MAEDA

Add redmine_plugin_migration generator (#31498).

Patch by Kouhei Sutou.

History

#1 - 2019-06-03 01:24 - Go MAEDA

- Target version set to Candidate for next major release

#2 - 2019-06-03 07:07 - vzvu 3k6k

I think that minimum implementation is a good starting point.

 +1, nice work!

This is a minute thing but `plugin_pretty_name` declared in line 16 of redmine_plugin_migration_generator.rb is not used so far and probably can be

safely removed.
#3 - 2019-06-03 07:10 - Kouhei Sutou

- File add-redmine-plugin-migration-generator-v2.diff added

Good catch.

I've updated the patch.

#4 - 2019-06-03 08:53 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

Setting the target version to 4.1.0.

#5 - 2019-06-03 16:56 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch. Thank you.

#6 - 2019-08-31 07:53 - Kuniharu AKAHANE

- Copied to Patch #31987: Add rake task which synchronize all revisions in repositories related with all active projects added

#7 - 2019-08-31 09:05 - Go MAEDA

- Copied to deleted (Patch #31987: Add rake task which synchronize all revisions in repositories related with all active projects)

Files

add-redmine-plugin-migration-generator.diff 1.84 KB 2019-06-02 Kouhei Sutou

add-redmine-plugin-migration-generator-v2.diff 1.8 KB 2019-06-03 Kouhei Sutou
